use crate::Solution;

impl Solution {
    /// [66.加一](https://leetcode-cn.com/problems/plus-one/)
    ///
    /// 2022-02-18 15:21:59
    ///
    /// 给定一个由 **整数** 组成的 **非空** 数组所表示的非负整数，在该数的基础上加一。
    ///
    /// 最高位数字存放在数组的首位， 数组中每个元素只存储**单个**数字。
    ///
    /// 你可以假设除了整数 0 之外，这个整数不会以零开头。
    ///
    /// + **示例 1：**
    ///     + **输入：** digits = \[1,2,3\]
    ///     + **输出：** \[1,2,4\]
    ///     + **解释：** 输入数组表示数字 123。
    /// + **示例 2：**
    ///     + **输入：** digits = \[4,3,2,1\]
    ///     + **输出：** \[4,3,2,2\]
    ///     + **解释：** 输入数组表示数字 4321。
    /// + **示例 3：**
    ///     + **输入：** digits = \[0\]
    ///     + **输出：** \[1\]
    /// + **提示：**
    ///     * `1 <= digits.length <= 100`
    ///     * `0 <= digits[i] <= 9`
    /// + Related Topics
    ///     * 数组
    ///     * 数学
    /// * 👍 920
    /// * 👎 0
    pub fn plus_one(mut digits: Vec<i32>) -> Vec<i32> {
        for i in (0..digits.len()).rev() {
            digits[i] += 1;
            digits[i] = digits[i] % 10;
            if digits[i] != 0 {
                return digits;
            }
        }
        let mut ret = vec![1];
        ret.extend(digits);
        ret
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0066() {
        assert_eq!(Solution::plus_one(vec![1, 2, 3]), vec![1, 2, 4]);
    }
}
