use crate::Solution;

impl Solution {
    /// [172.阶乘后的零](https://leetcode-cn.com/problems/factorial-trailing-zeroes/)
    ///
    /// 2022-02-18 16:48:55
    ///
    /// 给定一个整数 `n` ，返回 `n!` 结果中尾随零的数量。
    ///
    /// 提示 `n! = n * (n - 1) * (n - 2) * ... * 3 * 2 * 1`
    ///
    /// + **示例 1：**
    ///     + **输入：** n = 3
    ///     + **输出：** 0
    ///     + **解释：** 3! = 6 ，不含尾随 0
    /// + **示例 2：**
    ///     + **输入：** n = 5
    ///     + **输出：** 1
    ///     + **解释：** 5! = 120 ，有一个尾随 0
    /// + **示例 3：**
    ///     + **输入：** n = 0
    ///     + **输出：** 0
    /// + **提示：**
    ///     * `0 <= n <= 104`
    /// + **进阶：** 你可以设计并实现对数时间复杂度的算法来解决此问题吗？
    /// + Related Topics
    ///     * 数学
    /// * 👍 549
    /// * 👎 0
    pub fn trailing_zeroes(mut n: i32) -> i32 {
        let mut zero_count = 0;
        while n > 0 {
            n /= 5;
            zero_count += n;
        }
        zero_count
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0172() {
        assert_eq!(Solution::trailing_zeroes(5), 1);
    }
}
