use crate::Solution;


impl Solution {
    /// 283.移动零
    ///
    /// [原题链接](https://leetcode-cn.com/problems/move-zeroes/)
    ///
    /// 2021-07-20 22:21:24
    ///
    /// 给定一个数组 `nums`，编写一个函数将所有 `0` 移动到数组的末尾，同时保持非零元素的相对顺序。
    ///
    /// + 示例:
    ///     - 输入: `[0,1,0,3,12]`
    ///     - 输出: `[1,3,12,0,0]`
    /// + 说明:
    ///     - 必须在原数组上操作，不能拷贝额外的数组。
    ///     - 尽量减少操作次数。
    ///
    /// Related Topics 数组 双指针
    ///
    /// 👍 1131 👎 0
    pub fn move_zeroes(nums: &mut Vec<i32>) {
        /*let (mut l, mut r) = (0usize, 0usize);
        while r < nums.len() {
            if nums[r] != 0 {
                nums.swap(l, r);
                l += 1;
            }
            r += 1;
        }*/
        let mut i = 0;
        let mut n = nums.len();
        while i < n {
            if nums[i] == 0 {
                let val = nums.remove(i);
                nums.push(val);
                n -= 1;
                continue;
            }
            i += 1;
        }
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0283() {
        let mut nums = vec![0, 1, 0, 3, 12];
        Solution::move_zeroes(&mut nums);
        assert_eq!(nums, vec![1, 3, 12, 0, 0]);
    }
}
