use crate::Solution;


impl Solution {
    /// [412.Fizz Buzz](https://leetcode-cn.com/problems/fizz-buzz/)
    ///
    /// 2021-11-15 14:20:18
    ///
    /// 给你一个整数 `n` ，找出从 `1` 到 `n` 各个整数的 Fizz Buzz 表示，并用字符串数组 `answer`（**下标从 1 开始**）返回结果，其中：
    ///
    /// * `answer[i] == "FizzBuzz"` 如果 `i` 同时是 `3` 和 `5` 的倍数。
    /// * `answer[i] == "Fizz"` 如果 `i` 是 `3` 的倍数。
    /// * `answer[i] == "Buzz"` 如果 `i` 是 `5` 的倍数。
    /// * `answer[i] == i` 如果上述条件全不满足。
    ///
    /// * **示例 1：**
    ///     + **输入：** n = 3
    ///     + **输出：** \["1","2","Fizz"\]
    /// * **示例 2：**
    ///     + **输入：** n = 5
    ///     + **输出：** \["1","2","Fizz","4","Buzz"\]
    /// * **示例 3：**
    ///     + **输入：** n = 15
    ///     + **输出：** \["1","2","Fizz","4","Buzz","Fizz","7","8","Fizz","Buzz","11","Fizz","13","14","FizzBuzz"\]
    /// * **提示：**
    ///     * `1 <= n <= 104`
    /// * Related Topics
    ///     + 数学
    ///     + 字符串
    ///     + 模拟
    /// * 👍 156
    /// * 👎 0
    pub fn fizz_buzz(n: i32) -> Vec<String> {
        (1..=n).map(|i| if i % 3 == 0 { if i % 5 == 0 { "FizzBuzz".to_string() } else { "Fizz".to_string() } } else { if i % 5 == 0 { "Buzz".to_string() } else { i.to_string() } }).collect::<Vec<String>>()
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0412() {
        assert_eq!(Solution::fizz_buzz(5), vec!["1".to_string(), "2".to_string(), "Fizz".to_string(), "4".to_string(), "Buzz".to_string()]);
    }
}
