use crate::Solution;


impl Solution {
    /// 557.反转字符串中的单词 III
    ///
    /// [原题链接](https://leetcode-cn.com/problems/reverse-words-in-a-string-iii/)
    ///
    /// 2021-07-31 15:16:06
    ///
    /// 给定一个字符串，你需要反转字符串中每个单词的字符顺序，同时仍保留空格和单词的初始顺序。
    ///
    /// + 示例：
    ///     - 输入："Let's take LeetCode contest"
    ///     - 输出："s'teL ekat edoCteeL tsetnoc"
    /// + 提示：
    ///     - 在字符串中，每个单词由单个空格分隔，并且字符串中不会有任何额外的空格。
    ///
    /// Related Topics 双指针 字符串
    ///
    /// 👍 311 👎 0
    pub fn reverse_words(s: String) -> String {
        s.split(' ').into_iter().map(|a| unsafe { String::from_utf8_unchecked(a.bytes().rev().collect::<Vec<u8>>()) }).collect::<Vec<String>>().join(" ")
        //s.split_whitespace().into_iter().map(|a| a.chars().rev().collect::<String>()).collect::<Vec<String>>().join(" ")
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0557() {
        assert_eq!(Solution::reverse_words(String::from("Let's take LeetCode contest")), String::from("s'teL ekat edoCteeL tsetnoc"));
    }
}
