use crate::Solution;


impl Solution {
    /// 912.排序数组
    ///
    /// [原题链接](https://leetcode-cn.com/problems/sort-an-array/)
    ///
    /// 2021-07-16 11:08:54
    ///
    /// 给你一个整数数组 nums，请你将该数组升序排列。
    ///
    /// + 示例 1：
    ///     - 输入：`nums = [5,2,3,1]`
    ///     - 输出：`[1,2,3,5]`
    /// + 示例 2：
    ///     - 输入：`nums = [5,1,1,2,0,0]`
    ///     - 输出：`[0,0,1,1,2,5]`
    /// + 提示：
    ///     - `1 <= nums.length <= 50000`
    ///     - `-50000 <= nums[i] <= 50000`
    ///
    /// Related Topics 数组 分治 桶排序 计数排序 基数排序 排序 堆（优先队列） 归并排序
    ///
    /// 👍 318 👎 0
    pub fn sort_array(mut nums: Vec<i32>) -> Vec<i32> {
        std::collections::BinaryHeap::from(nums).into_sorted_vec()
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0912() {
        let nums = vec![5, 1, 1, 2, 0, 0];
        let ans = Solution::sort_array(nums);
        assert_eq!(ans, vec![0, 0, 1, 1, 2, 5]);
    }
}
