use crate::Solution;

impl Solution {
    /// [1108.IP 地址无效化](https://leetcode-cn.com/problems/defanging-an-ip-address/)
    ///
    /// 2022-02-21 18:03:40
    ///
    /// 给你一个有效的 [IPv4](https://baike.baidu.com/item/IPv4) 地址 `address`，返回这个 IP 地址的无效化版本。
    ///
    /// 所谓无效化 IP 地址，其实就是用 `"[.]"` 代替了每个 `"."`。
    ///
    /// + **示例 1：**
    ///     + **输入：** address = "1.1.1.1"
    ///     + **输出：** "1\[.\]1\[.\]1\[.\]1"
    /// + **示例 2：**
    ///     + **输入：** address = "255.100.50.0"
    ///     + **输出：** "255\[.\]100\[.\]50\[.\]0"
    /// + **提示：**
    ///     * 给出的 `address` 是一个有效的 IPv4 地址
    /// + Related Topics
    ///     * 字符串
    /// * 👍 77
    /// * 👎 0
    pub fn defang_i_paddr(address: String) -> String {
        address.replace(".", "[.]")
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1108() {
        assert_eq!(Solution::defang_i_paddr("1.1.1.1".to_string()), "1[.]1[.]1[.]1".to_string());
    }
}
