# [182.查找重复的电子邮箱](https://leetcode-cn.com/problems/duplicate-emails/)

2022-08-10 22:24:58

## SQL架构

```mysql
Create table If Not Exists Person
(
    id    int,
    email varchar(255)
);
Truncate table Person;

insert into Person (id, email)
values ('1', 'a@b.com');

insert into Person (id, email)
values ('2', 'c@d.com');

insert into Person (id, email)
values ('3', 'a@b.com');
```

## 题目

编写一个 SQL 查询，查找 `Person` 表中所有重复的电子邮箱。

**示例：**

```
+----+---------+
| Id | Email   |
+----+---------+
| 1  | a@b.com |
| 2  | c@d.com |
| 3  | a@b.com |
+----+---------+

```

根据以上输入，你的查询应返回以下结果：

```
+---------+
| Email   |
+---------+
| a@b.com |
+---------+

```

**说明：**所有电子邮箱都是小写字母。

Related Topics

* 数据库

## 解

```mysql
select Email
from (select Email, count(Email) as num
      from Person
      group by Email) as statistic
where num > 1;
```

```mysql
select Email
from Person
group by Email
having count(Email) > 1;
```