/**
 * 1486.数组异或操作
 * @param {number} n
 * @param {number} start
 * @return {number}
 * @see https://leetcode-cn.com/problems/xor-operation-in-an-array/
 */
const xorOperation = function (n, start) {
    return (start & 3) < 2 ? ((n & 1) === 0) ? (n & 3) : (start + 2 * n - 3 + (n & 3)) : ((n & 1) === 0) ? ((start + (n - 1) * 2) ^ (start - 2 + (n & 3))) : (start + 1 - (n & 3));
};

/**
 * 69.x 的平方根
 * @param {number} x
 * @return {number}
 * @see https://leetcode-cn.com/problems/sqrtx/
 */
const mySqrt = function (x) {
    const xHalf = 0.5 * x;
    let i = new BigInt64Array(new Float64Array([x]).buffer)[0];
    i = 0x1FF7A3BEA91D9B1Bn + (i >> 1n);
    let f = new Float64Array(new BigInt64Array([i]).buffer)[0];
    f = f * 0.5 + xHalf / f;
    f = f * 0.5 + xHalf / f;
    f = f * 0.5 + xHalf / f;
    return Math.floor(f);
};

/**
 * @param {number[]} nums
 * @return {number}
 */
const missingNumber = function (nums) {
    return [nums.length, 1, nums.length + 1, 0][nums.length & 3] ^ nums.reduce((o, n) => o ^ n, 0);
};
