use crate::Solution;


impl Solution {
    /// [剑指 Offer 64.求1+2+…+n](https://leetcode-cn.com/problems/qiu-12n-lcof/)
    ///
    /// 2021-11-15 11:13:49
    ///
    /// 求 `1+2+...+n` ，要求不能使用乘除法、for、while、if、else、switch、case等关键字及条件判断语句（A\?B:C）。
    ///
    /// * **示例 1：**
    ///     + **输入:** n = 3
    ///     + **输出:** 6
    /// * **示例 2：**
    ///     + **输入:** n = 9
    ///     + **输出:** 45
    /// * **限制：**
    ///     * `1 <= n <= 10000`
    /// * Related Topics
    ///     + 位运算
    ///     + 递归
    ///     + 脑筋急转弯
    /// * 👍 400
    /// * 👎 0
    pub fn sum_nums(n: i32) -> i32 {
        /*assert!(1 <= n && n <= 10000);
        let x = n + 1;
        let mut sum = 0;
        (x & 0x0001 != 0) && (sum += n) == ();
        (x & 0x0002 != 0) && (sum += n << 0x1) == ();
        (x & 0x0004 != 0) && (sum += n << 0x2) == ();
        (x & 0x0008 != 0) && (sum += n << 0x3) == ();
        (x & 0x0010 != 0) && (sum += n << 0x4) == ();
        (x & 0x0020 != 0) && (sum += n << 0x5) == ();
        (x & 0x0040 != 0) && (sum += n << 0x6) == ();
        (x & 0x0080 != 0) && (sum += n << 0x7) == ();
        (x & 0x0100 != 0) && (sum += n << 0x8) == ();
        (x & 0x0200 != 0) && (sum += n << 0x9) == ();
        (x & 0x0400 != 0) && (sum += n << 0xA) == ();
        (x & 0x0800 != 0) && (sum += n << 0xB) == ();
        (x & 0x1000 != 0) && (sum += n << 0xC) == ();
        (x & 0x2000 != 0) && (sum += n << 0xD) == ();
        sum = sum >> 1;
        return sum;*/
        (n.pow(2) + n) >> 1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_j1064() {
        let n = 100;
        assert_eq!(Solution::sum_nums(n), n * (n + 1) / 2);
    }
}
