use crate::Solution;

impl Solution {
    /// [面试题 08.03.魔术索引](https://leetcode.cn/problems/magic-index-lcci/)
    ///
    /// 2022-08-09 10:18:13
    ///
    /// 魔术索引。 在数组`A[0...n-1]`中，有所谓的魔术索引，满足条件`A[i] = i`。给定一个有序整数数组，编写一种方法找出魔术索引，若有的话，在数组A中找出一个魔术索引，如果没有，则返回-1。若有多个魔术索引，返回索引值最小的一个。
    ///
    /// + **示例1:**
    ///     + **输入**：nums = \[0, 2, 3, 4, 5\]
    ///     + **输出**：0
    ///     + **说明**: 0下标的元素为0
    /// + **示例2:**
    ///     + **输入**：nums = \[1, 1, 1\]
    ///     + **输出**：1
    /// + **说明:**
    ///     1. nums长度在\[1, 1000000\]之间
    ///     2. 此题为原书中的 Follow-up，即数组中可能包含重复元素的版本
    /// + Related Topics
    ///     * 数组
    ///     * 二分查找
    pub fn find_magic_index(nums: Vec<i32>) -> i32 {
        for (i, val) in nums.into_iter().enumerate() {
            if val as usize == i {
                return i as i32;
            }
        }
        -1
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_m0803() {
        assert_eq!(Solution::find_magic_index(vec![0, 2, 3, 4, 5]), 0);
    }
}
