use crate::Solution;

impl Solution {
    /// [面试题 16.01.交换数字](https://leetcode.cn/problems/swap-numbers-lcci/)
    ///
    /// 2022-08-09 10:12:25
    ///
    /// 编写一个函数，不用临时变量，直接交换`numbers = [a, b]`中`a`与`b`的值。
    ///
    /// + **示例：**
    ///     + **输入:** numbers = \[1,2\]
    ///     + **输出:** \[2,1\]
    /// + **提示：**
    ///     * `numbers.length == 2`
    ///     * `-2147483647 <= numbers[i] <= 2147483647`
    /// + Related Topics
    ///     * 位运算
    ///     * 数学
    pub fn swap_numbers(mut numbers: Vec<i32>) -> Vec<i32> {
        numbers[0] ^= numbers[1];
        numbers[1] ^= numbers[0];
        numbers[0] ^= numbers[1];
        numbers
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_m1601() {
        assert_eq!(Solution::swap_numbers(vec![1, 2]), vec![2, 1]);
    }
}
