use crate::Solution;


impl Solution {
    /// 136.只出现一次的数字
    ///
    /// [原题链接](https://leetcode-cn.com/problems/single-number/)
    ///
    /// 2021-08-01 10:16:30
    ///
    /// 给定一个非空整数数组，除了某个元素只出现一次以外，其余每个元素均出现两次。找出那个只出现了一次的元素。
    ///
    /// + 说明：
    ///     - 你的算法应该具有线性时间复杂度。你可以不使用额外空间来实现吗？
    /// + 示例 1:
    ///     - 输入: `[2,2,1]`
    ///     - 输出: `1`
    /// + 示例 2:
    ///     - 输入: `[4,1,2,1,2]`
    ///     - 输出: `4`
    /// Related Topics 位运算 数组
    ///
    /// 👍 1942 👎 0
    pub fn single_number(nums: Vec<i32>) -> i32 {
        nums.into_iter().fold(0, |a, n| n ^ a)
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0136() {
        assert_eq!(Solution::single_number(vec![4, 1, 2, 1, 2]), 4);
    }
}
