use crate::Solution;

impl Solution {
    /// [217.存在重复元素](https://leetcode-cn.com/problems/contains-duplicate/)
    ///
    /// 2022-02-18 17:07:55
    ///
    /// 给你一个整数数组 `nums` 。如果任一值在数组中出现 **至少两次** ，返回 `true` ；如果数组中每个元素互不相同，返回 `false` 。
    ///
    /// + **示例 1：**
    ///     + **输入：** nums = \[1,2,3,1\]
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：** nums = \[1,2,3,4\]
    ///     + **输出：** false
    /// + **示例 3：**
    ///     + **输入：** nums = \[1,1,1,3,3,4,3,2,4,2\]
    ///     + **输出：** true
    /// + **提示：**
    ///     * `1 <= nums.length <= 105`
    ///     * `-109 <= nums[i] <= 109`
    /// + Related Topics
    ///     * 数组
    ///     * 哈希表
    ///     * 排序
    /// * 👍 626
    /// * 👎 0
    pub fn contains_duplicate(nums: Vec<i32>) -> bool {
        let mut set = std::collections::HashSet::<i32>::new();
        for n in nums {
            if !set.insert(n) {
                return true;
            }
        }
        false
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0217() {
        assert_eq!(Solution::contains_duplicate(vec![1, 2, 3, 1]), true);
    }
}
