use crate::Solution;


impl Solution {
    /// [258.各位相加](https://leetcode-cn.com/problems/add-digits/)
    ///
    /// 2021-11-12 09:55:16
    ///
    /// 给定一个非负整数 `num`，反复将各个位上的数字相加，直到结果为一位数。
    ///
    /// * **示例:**
    ///     + **输入:** `38`
    ///     + **输出:** 2
    ///     + **解释:** 各位相加的过程为 **：**`3 + 8 = 11`, `1 + 1 = 2`。 由于 `2` 是一位数，所以返回 2。
    /// * **进阶:**
    ///     + 你可以不使用循环或者递归，且在 O\(1\) 时间复杂度内解决这个问题吗？
    /// * Related Topics
    ///     + 数学
    ///     + 数论
    ///     + 模拟
    /// * 👍 380
    /// * 👎 0
    pub fn add_digits(num: i32) -> i32 {
        (num - 1) % 9 + 1
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0258() {
        assert_eq!(Solution::add_digits(38), 2);
    }
}
