use crate::Solution;

impl Solution {
    /// [326.3 的幂](https://leetcode-cn.com/problems/power-of-three/)
    ///
    /// 2022-02-18 17:41:24
    ///
    /// 给定一个整数，写一个函数来判断它是否是 3 的幂次方。如果是，返回 `true` ；否则，返回 `false` 。
    ///
    /// 整数 `n` 是 3 的幂次方需满足：存在整数 `x` 使得 `n == 3x`
    ///
    /// + **示例 1：**
    ///     + **输入：** n = 27
    ///     + **输出：** true
    /// + **示例 2：**
    ///     + **输入：** n = 0
    ///     + **输出：** false
    /// + **示例 3：**
    ///     + **输入：** n = 9
    ///     + **输出：** true
    /// + **示例 4：**
    ///     + **输入：** n = 45
    ///     + **输出：** false
    /// + **提示：**
    ///     * `-231 <= n <= 231 - 1`
    /// + **进阶：** 你能不使用循环或者递归来完成本题吗？
    /// + Related Topics
    ///     * 递归
    ///     * 数学
    /// * 👍 244
    /// * 👎 0
    pub fn is_power_of_three(n: i32) -> bool {
        n > 0 && 0x4546B3DB % n == 0
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0326() {
        assert_eq!(Solution::is_power_of_three(27), true);
    }
}
