use crate::Solution;

impl Solution {
    /// [343.整数拆分](https://leetcode-cn.com/problems/integer-break/)
    ///
    /// 2022-02-21 10:12:14
    ///
    /// 给定一个正整数 `n` ，将其拆分为 `k` 个 **正整数** 的和（ `k >= 2` ），并使这些整数的乘积最大化。
    ///
    /// 返回 _你可以获得的最大乘积_ 。
    ///
    /// + **示例 1:**
    ///     + **输入:** n = 2
    ///     + **输出:** 1
    ///     + **解释:** 2 = 1 + 1, 1 × 1 = 1。
    /// + **示例 2:**
    ///     + **输入:** n = 10
    ///     + **输出:** 36
    ///     + **解释:** 10 = 3 + 3 + 4, 3 × 3 × 4 = 36。
    /// + **提示:**
    ///     * `2 <= n <= 58`
    /// + Related Topics
    ///     * 数学
    ///     * 动态规划
    /// * 👍 712
    /// * 👎 0
    pub fn integer_break(n: i32) -> i32 {
        match n {
            n if n <= 3 => n - 1,
            _ => match n % 3 {
                0 => 3i32.pow((n / 3) as u32),
                1 => (3i32.pow((n / 3) as u32 - 1) * 4),
                _ => (3i32.pow((n / 3) as u32) * 2)
            }
        }
        /*if n <= 3 {
            return n - 1;
        }
        let q = (n / 3) as u32;
        match n % 3 {
            0 => 3i32.pow(q),
            1 => (3i32.pow(q - 1) * 4),
            _ => (3i32.pow(q) * 2)
        }*/
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0343() {
        assert_eq!(Solution::integer_break(10), 36)
    }
}
