use crate::Solution;


impl Solution {
    /// [367.有效的完全平方数](https://leetcode-cn.com/problems/valid-perfect-square/)
    ///
    /// 2021-11-04 08:45:15
    ///
    /// 给定一个 **正整数** `num` ，编写一个函数，如果 `num` 是一个完全平方数，则返回 `true` ，否则返回 `false` 。
    ///
    /// **进阶：不要** 使用任何内置的库函数，如 `sqrt` 。
    ///
    /// **示例 1：**
    ///
    /// **输入：** num = 16
    ///
    /// **输出：** true
    ///
    /// **示例 2：**
    ///
    /// **输入：** num = 14
    ///
    /// **输出：** false
    ///
    /// **提示：**
    ///
    /// * `1 <= num <= 2^31 - 1`
    ///
    /// Related Topics
    ///
    /// + 数学
    /// + 二分查找
    ///
    /// * 👍 258
    /// * 👎 0
    pub fn is_perfect_square(num: i32) -> bool {
        /*let mut x0 = num as f64;
        loop {
            let x1 = (x0 + num as f64 / x0) / 2.0;
            if x0 - x1 < 1e-6 {
                break x0 as i32;
            }
            x0 = x1;
        }.pow(2) == num*/
        /*let h = 0.5 * num as f64;
        let mut f =  f64::from_bits(0x5FE6EC85E7DE30DA - ((num as f64).to_bits() >> 1));
        f = f * (1.5 - h * f * f);
        f = f * (1.5 - h * f * f);
        f = f * (1.5 - h * f * f);
        ((1.0 / f) as i32).pow(2) == num*/
        let x_half = 0.5 * num as f32;
        let mut i = (num as f32).to_bits();
        i = 0x1FBD1DF5 + (i >> 1);
        let mut f = f32::from_bits(i);
        f = 0.5 * f + x_half / f;
        f = 0.5 * f + x_half / f;
        (f as i32).pow(2) == num
    }
}


#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q0367() {
        assert_eq!(Solution::is_perfect_square(2147395600), true);
    }
}
