use crate::Solution;

impl Solution {
    /// [1422.分割字符串的最大得分](https://leetcode.cn/problems/maximum-score-after-splitting-a-string/)
    ///
    /// 2022-08-17 14:24:53
    ///
    /// 给你一个由若干 0 和 1 组成的字符串 `s` ，请你计算并返回将该字符串分割成两个 **非空** 子字符串（即 **左** 子字符串和 **右** 子字符串）所能获得的最大得分。
    ///
    /// 「分割字符串的得分」为 **左** 子字符串中 **0** 的数量加上 **右** 子字符串中 **1** 的数量。
    ///
    /// + **示例 1：**
    ///     + **输入：** s = "011101"
    ///     + **输出：** 5
    ///     + **解释：**
    ///         + 将字符串 s 划分为两个非空子字符串的可行方案有：
    ///         + 左子字符串 = "0" 且 右子字符串 = "11101"，得分 = 1 + 4 = 5
    ///         + 左子字符串 = "01" 且 右子字符串 = "1101"，得分 = 1 + 3 = 4
    ///         + 左子字符串 = "011" 且 右子字符串 = "101"，得分 = 1 + 2 = 3
    ///         + 左子字符串 = "0111" 且 右子字符串 = "01"，得分 = 1 + 1 = 2
    ///         + 左子字符串 = "01110" 且 右子字符串 = "1"，得分 = 2 + 1 = 3
    /// + **示例 2：**
    ///     + **输入：** s = "00111"
    ///     + **输出：** 5
    ///     + **解释：** 当 左子字符串 = "00" 且 右子字符串 = "111" 时，我们得到最大得分 = 2 + 3 = 5
    /// + **示例 3：**
    ///     + **输入：** s = "1111"
    ///     + **输出：** 3
    /// + **提示：**
    ///     * `2 <= s.length <= 500`
    ///     * 字符串 `s` 仅由字符 `'0'` 和 `'1'` 组成。
    /// + Related Topics
    ///     * 字符串
    pub fn max_score(s: String) -> i32 {
        /*let bytes = s.into_bytes();
        let s1 = bytes.iter().filter(|&&b| b == b'0').count();
        let s2 = bytes.len() - s1;
        if s1 == 0 || s2 == 0 {
            return (bytes.len() - 1) as i32;
        }
        let (mut t, mut count) = (0, 0);
        for i in 1..bytes.len() {
            if bytes[i - 1] == b'0' {
                count += 1;
            }
            let curr = count + s2 - (i - count);
            if t < curr {
                t = curr;
            }
        }
        t as i32*/
        match (1..s.len()).into_iter().fold((i32::MIN, 0i32, s.into_bytes()), |(m, o, b), i| (m.max(i as i32 - (o + (b[i - 1] - b'0') as i32) * 2), o + (b[i - 1] - b'0') as i32, b)) {
            (m, o, b) => m + o + (b[b.len() - 1] - b'0') as i32
        }
        //unimplemented!()
    }
}

#[cfg(test)]
mod test {
    use crate::Solution;

    #[test]
    fn test_q1422() {
        assert_eq!(Solution::max_score("011101".to_owned()), 5);
        assert_eq!(Solution::max_score("00111".to_owned()), 5);
        assert_eq!(Solution::max_score("1111".to_owned()), 3);
    }
}
